Description

while Profiling a 6.2 installation with XHProf I found that the most expensive part of the request is always the classloader cache - no
matter which CF backend is used for it.

the attached callgraphs both show the delivery of a cached page, one with the default configuration (simple file backend) and one with
the classloader cache Backend set to memcached.

In both cases we see that either file_get_contents() or Memcach::get() is the most expensive function.

the request times (mesured with the adminPanel) are almost the same in both cases: ~155ms with simple file backend and 150 ms
with memcache

Since memcache should be way faster than the filesystem I think there's a lot of room for optimizing in the classloader.

Related issues:
related to Core - Bug # 55029: Class Loader fails if entry in class cache is ... Closed 2014-01-15

History
#1 - 2014-01-14 17:09 - Markus Klein
- Parent task set to #52949

#2 - 2014-01-15 11:59 - Helmut Hummel

Hi Rupi,

Rupert Germann wrote:

Since memcache should be way faster than the filesystem I think there's a lot of room for optimizing in the classloader.

I'm looking at the graph and the code and really asking myself where the room is for optimizing. Given the cache is populated, the code is pretty
straightforward and only does 3 things:

    1. lookup the cache entry
    2. get the cache entry
    3. require the class file
Can you elaborate how this could be optimized?

#3 - 2014-01-15 12:08 - Helmut Hummel

Rupert Germann wrote:

In both cases we see that either file_get_contents() or Memcach::get() is the most expensive function.

The memcache backend is also not optimal here. Can you check the performance with an APC backend?

#4 - 2014-01-15 14:16 - Helmut Hummel

Numbers from my Server for incl wall time of loadClass

    1. SimpleFileBackend: 61,557
    2. ApcBackend: 23,505

APC is roughly 3 times faster

#5 - 2014-01-15 22:41 - Helmut Hummel
- Status changed from New to Needs Feedback

#6 - 2014-01-15 23:20 - Helmut Hummel
- Status changed from Needs Feedback to New

#7 - 2014-01-16 16:38 - Ingo Schmitt
- Parent task changed from #52949 to #55073

#8 - 2014-01-20 16:33 - Ingo Schmitt
- Category set to Performance

#9 - 2014-01-20 17:52 - Rupert Germann

Yes, indeed APC is way faster here. 
But the point is: I don't want to use accelerators just to make a site usable. 
In case I really need an accelerator because my site has a huge load than I'm already out of options.

#10 - 2015-01-24 09:40 - Mathias Schreiber
- Status changed from New to Resolved

composer classloader solves this
http://stackoverflow.com/questions/7196660/proof-memcache-is-faster-than-file-system-caching

